var st_enabled = false;
var st_unloadstate = false;

//checks Stealther state
function st_getState() {
  if (prefs.getPrefType(est+"enabled") == prefs.PREF_BOOL)
  	st_enabled = prefs.getBoolPref(est+"enabled");
  else
    prefs.setBoolPref(est+"enabled",false);
  if (prefs.getPrefType(est+"unloadstate") == prefs.PREF_BOOL)
  	st_unloadstate = prefs.getBoolPref(est+"unloadstate");
  else
  	prefs.setBoolPref(est+"unloadstate",false);
}

function st_storeSettings() {
	if (!st_enabled) {
		prefs.setIntPref(est+"browser.history_expire_days",prefs.getIntPref("browser.history_expire_days"));
		prefs.setIntPref(est+"browser.history_expire_days_min",prefs.getIntPref("browser.history_expire_days_min"));
		prefs.setIntPref(est+"browser.download.manager.retention",prefs.getIntPref("browser.download.manager.retention"));
		prefs.setBoolPref(est+"browser.cache.disk.enable",prefs.getBoolPref("browser.cache.disk.enable"));
		prefs.setBoolPref(est+"browser.formfill.enable",prefs.getBoolPref("browser.formfill.enable"));
		prefs.setIntPref(est+"network.cookie.cookieBehavior",prefs.getIntPref("network.cookie.cookieBehavior"));
		prefs.setIntPref(est+"network.http.sendRefererHeader",prefs.getIntPref("network.http.sendRefererHeader"));
		prefs.setIntPref(est+"browser.sessionstore.max_tabs_undo",prefs.getIntPref("browser.sessionstore.max_tabs_undo"));
	}
}
//store the settings on load
st_getState();
st_storeSettings();

//sets UI based on state
function st_setUI() {
  var stealther_menuObj = document.getElementById("menu_Stealther");
	stealther_menuObj.setAttribute("checked",st_enabled);
	if (prefs.getPrefType(est+"menuhide") == prefs.PREF_BOOL) stealther_menuObj.setAttribute("hidden",prefs.getBoolPref(est+"menuhide",""));
	var stealtherButton = document.getElementById("stealther-button");
  if (stealtherButton) {
    if (st_enabled)
      stealtherButton.setAttribute("default", "false");
    else
      stealtherButton.removeAttribute("default");
  }
  
  var stealtherStatus = window.document.getElementById("stealther-status-bar");
  if (stealtherStatus) {
    if ( (prefs.getPrefType(est+"showstatus") == prefs.PREF_BOOL)
	 && (prefs.getBoolPref(est+"showstatus","")) )
	  stealtherStatus.setAttribute("hidden", !st_enabled);
    else 
	  stealtherStatus.setAttribute("hidden", true);
  }
  
  var stealtherKey = window.document.getElementById("stealther-toggle-key");
  if (stealtherKey) {
    if (prefs.getPrefType(est+"togglekey") == prefs.PREF_STRING)
      stealtherKey.setAttribute("key",prefs.getCharPref(est+"togglekey","S"));
  }
}

//checks unloadstate and sets UI
function st_onStart() {
  st_getState();
  if (st_unloadstate) {
    stealther_toggle();
  	prefs.setBoolPref(est+"unloadstate",false);
  } else st_setUI();
}

//disables stealther
function st_onQuit() {
  st_getState();
  prefs.setBoolPref(est+"unloadstate",st_enabled);
  if (st_enabled) stealther_toggle();
}

window.addEventListener("load", st_onStart, false);
window.addEventListener("unload", st_onQuit, false);
window.addEventListener("focus", st_onStart, false);

//main toggle function
function stealther_toggle() {
  st_getState();
	st_storeSettings();
	st_enabled = !st_enabled;
	prefs.setBoolPref(est+"enabled",st_enabled);
	st_setUI();
  
  //read options
  if (prefs.getPrefType(est+"options") == prefs.PREF_STRING) {
    optionStr=prefs.getCharPref(est+"options","");
    optionArray=st_explodeArray(optionStr,";");
  } else {
    optionArray = new Array(7);
    for (i=0;i<6;i++) optionArray[i]="true";
  }

  //modify FF preferences
	if (st_enabled) {
		if (optionArray[0]=="true") prefs.setIntPref("browser.history_expire_days",0);
		if (optionArray[0]=="true") prefs.setIntPref("browser.history_expire_days_min",0);
		if (optionArray[1]=="true") prefs.setIntPref("browser.download.manager.retention",0);
		if (optionArray[2]=="true") prefs.setBoolPref("browser.cache.disk.enable",false);
		if (optionArray[3]=="true") prefs.setBoolPref("browser.formfill.enable",false);
		if (optionArray[4]=="true") prefs.setIntPref("network.cookie.cookieBehavior",2);
		if (optionArray[5]=="true") prefs.setIntPref("network.http.sendRefererHeader",0);
		if (optionArray[6]=="true") prefs.setIntPref("browser.sessionstore.max_tabs_undo",0);
	} else {
		if (optionArray[0]=="true") prefs.setIntPref("browser.history_expire_days",prefs.getIntPref(est+"browser.history_expire_days"));
		if (optionArray[0]=="true") prefs.setIntPref("browser.history_expire_days_min",prefs.getIntPref(est+"browser.history_expire_days_min"));
		if (optionArray[1]=="true") prefs.setIntPref("browser.download.manager.retention",prefs.getIntPref(est+"browser.download.manager.retention"));
		if (optionArray[2]=="true") prefs.setBoolPref("browser.cache.disk.enable",prefs.getBoolPref(est+"browser.cache.disk.enable"));
		if (optionArray[3]=="true") prefs.setBoolPref("browser.formfill.enable",prefs.getBoolPref(est+"browser.formfill.enable"));
		if (optionArray[4]=="true") prefs.setIntPref("network.cookie.cookieBehavior",prefs.getIntPref(est+"network.cookie.cookieBehavior"));
		if (optionArray[5]=="true") prefs.setIntPref("network.http.sendRefererHeader",prefs.getIntPref(est+"network.http.sendRefererHeader"));
		if (optionArray[6]=="true") prefs.setIntPref("browser.sessionstore.max_tabs_undo",prefs.getIntPref(est+"browser.sessionstore.max_tabs_undo"));
	}
}
